/*
Logic :

Geo
Lang

// Retargeting - Priority 1 
// Input : Geo_Lang_Pid via cookie
1. Retargeting cookie available?
2. If yes, 4 or less?
3. If 4, show all 4.
4. If less than 4, what is the gender and cat of all available?
5. Make a call to gender_cat db and get rest of the products.
6. Populate them in the Ad.

//Audience catagory Id via DS1 (Feed) - Priority 2
// Input : Geo_Lang_AudienceId - This will give us enough creative. In case of less creative - majority
1. Look at DS1 and get the Audience id.
2. Make a call to Audience db and get the set of products.
3. Populate them in the Ad.

//Prospecting DCM Id via DS2 (Google sheet) - Priority 3
// Input : This will tell us Catogory
1. Look at DS1 and get the Audience id.
2. Make a call to Audience db and get the set of products.
3. Populate them in the Ad.

//Default - Geo_Lang Default - Priority 4
//Default - Universal Default - Priority 5
*/

//Start of the widget.
;
console.log('Dynamic data :', dynamicData);
//console.log('DynamicJSONData :', parent.dynamicJSONData);
 
if (typeof ap_geoLang != "undefined")
    console.log('ap_geoLang from preprocessing :', ap_geoLang);

(function(_root, _jvxAd, _dataset) {
	//console.log(ap_geoLang,"we are getting");
    //ap_geoLang = "united kingdom_english";
    //ap_geoLang = "NA_NA";
    console.log('_dataset :', _dataset, ap_geoLang);

   var widget = widget || {};
    widget.defaults = {
        //ap_geoLang: (function() {
        //    return (typeof ap_geoLang !== "undefined") ? ap_geoLang : "united kingdom_tagalog";
        //}()),
        adSize: dynamicData['campaignProperties:campaignProperties.creativeDim'],
        numberOfProducts: 4,
		productids : []
    }
	var strategy,default_strategy,geoValue,langValue,dspValuevar,category_value,gender_value;
    //reportingupdate
	var reportingPrefix = "rep1";
	console.log('############### reportingPrefix stage1 retargeting')

    function arrayMaxRepeat(array) {
        if (array.length == 0)
            return null;
        var modeMap = {};
        var maxEl = array[0],
            maxCount = 1;
        for (var i = 0; i < array.length; i++) {
            var el = array[i];
            if (modeMap[el] == null)
                modeMap[el] = 1;
            else
                modeMap[el]++;
            if (modeMap[el] > maxCount) {
                maxEl = el;
                maxCount = modeMap[el];
            }
        }
        return maxEl;
    };


    (function() {
        //console.log('widget.defaults :',widget.defaults);
        //console.log('geo:geo.country', dynamicData['geo:geo.country'], "ap_geoLang : ", ap_geoLang);


        var self = this,
            productSet = [],
            productIds = [],
            getCatagory = [],
            getGender = [];

        this.getDynamicData = function(key) {
            if (typeof _dataset !== "undefined" && typeof _dataset[key] !== "undefined") return _dataset[key];
            else return false;
        }
        this.dynamicDataCallback = function(dbName, keyTrigger, callbackFn) {
            var responseString = jvxAd.assetDBReq(dbName).keys(keyTrigger).order("random").build();
            _jvxAd.dynamicDataCallback(callbackFn).get(responseString);
        }
        this.isRetargeting = function() {
            return JSON.parse(self.getDynamicData('cookieData:cookieData.jvxdynsl-isSet'));
        };

        this.generateGallery = function(result,creativeVariationReporting,customWidgetReporting) {
            console.log('generateGallery loadeds', result);
            //result = result[Object.keys(result)[0]];
            //console.log('generateGallery products result : ', result);
            //console.log('#################');
            
            
            //resize code wip
            switch (dynamicData['campaignProperties:campaignProperties.creativeDim']) {
				case '300x250':
					var imageContainerWidth = 190,
						imageContainerHeight = 95,
						imageBottom = 74,
						imageTop = 82,
						actualHeightLess = 85,
						setTop = 88,
						creativeDim = "300x250";
					break;
				case '120x600':
					var imageContainerWidth = 110,
						imageContainerHeight = 60,
						imageBottom = 300,
						imageTop = 240,
						actualHeightLess = 55,
						setTop = 244,
						creativeDim = "120x600";
					break;
				 case '160x600':
					var imageContainerWidth = 150,
						imageContainerHeight = 75,
						imageBottom = 300,
						imageTop = 230,
						actualHeightLess = 70,
						setTop = 234,
						creativeDim = "160x600";
					break;
				case '250x250':
					var imageContainerWidth = 180,
						imageContainerHeight = 83,
						imageBottom = 74,
						imageTop = 83,
						actualHeightLess = 75,
						setTop = 88,
						creativeDim = "250x250";
					break;
				case '300x300':
					var imageContainerWidth = 210,
						imageContainerHeight = 110,
						imageBottom = 74,
						imageTop = 94,
						actualHeightLess = 100,
						setTop = 101,
						creativeDim = "300x300";
					break;
				case '300x600':
					var imageContainerWidth = 250,
						imageContainerHeight =115,
						imageBottom = 300,
						imageTop = 245,
						actualHeightLess = 110,
						setTop = 250,
						creativeDim = "300x600";
					break;
				case '320x50':
					var imageContainerWidth = 85,
						imageContainerHeight = 45,
						imageTop = 2,
						imageLeft = 155,
						creativeDim = "320x50";
					break;	
				 case '728x90':
					var imageContainerWidth = 150,
						imageContainerHeight = 80,
						imageBottom = 5,
						imageRight = 216,
						creativeDim = "728x90";
					break;
				case '970x250':
					var imageContainerWidth = 280,
						imageContainerHeight = 144,
						imageBottom = 15,
						imageRight = 650,
						unitHeight_1 = 180, //from top to title height
						creativeDim = "970x250";
					break;
				
				default:
					var imageContainerWidth = 190,
						imageContainerHeight = 95,
						imageBottom = 74;
			}
            
            var productReporting = [];
			var colorReporting = [];
			var modeltypeReporting = [];
			var product_colorReporting = [];
            var priority = creativeVariationReporting.split("_")[0];
			console.log("priorityVal",priority);
            for (var key in result) {
                
                document.getElementsByClassName("product")[key].src = result[key][result[key]['Image_column_used']].replace("http:", "https:");
                document.getElementsByClassName("name")[key].innerHTML = result[key]['style_line1'];
				
				if(priority == "LineItemIds" || priority == "GeoLanguageDefault" || priority == "BaseDefault"){
					if((priority == "LineItemIds" || priority == "GeoLanguageDefault" || priority == "BaseDefault") && key =="0"){
						function loadcssfile(filename, filetype){
							if (filetype=="css"){ //if filename is an external CSS file
								var fileref=document.createElement("link")
								fileref.setAttribute("rel", "stylesheet")
								fileref.setAttribute("type", "text/css")
								fileref.setAttribute("href", filename)
							}
						 
							if (typeof fileref!="undefined"){
								document.getElementsByTagName("head")[0].appendChild(fileref);
							}
						}
						function loadjsfile(filename, filetype){
							if (filetype=="js"){ //if filename is a external JavaScript file
								var fileref=document.createElement('script')
								fileref.setAttribute("type","text/javascript")
								fileref.setAttribute("src", filename)
							}
							if (typeof fileref!="undefined"){
								document.getElementsByTagName("body")[0].appendChild(fileref);
							}
						}
						$('#myScript').remove();
						loadcssfile("css/"+widget.defaults.adSize+".css", "css");
						loadjsfile("js/"+widget.defaults.adSize+".js", "js");
					}
					document.getElementsByClassName("price")[key].innerHTML = result[key]['style_line2'];
				}else{
				var salePrice = result[key]['SalePrice'],
					offPrice = result[key]['Price'],
					salePercentage = result[key]['sale_percentage'],
					priceLen = offPrice.length;
				if((salePercentage == "0%") && (salePrice == offPrice)){
					document.getElementsByClassName("price")[key].innerHTML = result[key]['Price'];
				}else{
					if(widget.defaults.adSize == "320x50"){
						document.getElementsByClassName("name")[key].style.cssText += "left:36px;width:115px;"
						document.getElementsByClassName("price")[key].style.cssText += "left:36px;width:115px;"
						document.getElementsByClassName("saleWidth")[key].style.cssText += "left:10px;width:118px;"
					}
					document.getElementsByClassName("sale-corner")[key].style.cssText += "display:block";
					var priceVal = document.getElementsByClassName("sale-corner")[key].innerHTML;
					document.getElementsByClassName("sale-corner")[key].innerHTML = priceVal.replace("XX%",salePercentage);
					if((offPrice.charAt(0) == "£") || (offPrice.charAt(0) == "$")){
						var firstChar = offPrice.charAt(0),
							subPrice = offPrice.substring(1, offPrice.length);
						if(widget.defaults.adSize == "120x600" && priceLen > 9){
							document.getElementsByClassName("price")[key].innerHTML = firstChar + subPrice.strike() +"<br>"+salePrice;
						}else{
							document.getElementsByClassName("price")[key].innerHTML = firstChar + subPrice.strike() + "&nbsp &nbsp"+salePrice;
						}
					}else{
						var salePriceCheck = offPrice.split(" ")[1],
							 checkVal = salePriceCheck.charAt(0),
							 reg = new RegExp('^[0-9]+$'),
							 val = reg.test(checkVal);
						 if(val == true){
							 if(widget.defaults.adSize == "120x600" && priceLen > 9){
								 document.getElementsByClassName("price")[key].innerHTML = offPrice.split(" ")[0] + " " + offPrice.split(" ")[1].strike() +"<br>"+salePrice;
							 }else{
								document.getElementsByClassName("price")[key].innerHTML = offPrice.split(" ")[0] + " " + offPrice.split(" ")[1].strike() +"&nbsp &nbsp"+salePrice;
							 }
						 }else{
							 if(widget.defaults.adSize == "120x600" && priceLen > 9){
								 document.getElementsByClassName("price")[key].innerHTML = offPrice.strike() +"<br>"+salePrice;
							 }else{
								document.getElementsByClassName("price")[key].innerHTML = offPrice.strike() +"&nbsp &nbsp"+salePrice;
							 }
						}
					}
				}
			}
                
			if ((typeof dynamicData != "undefined") && (typeof dynamicData['Dynamic_BG'] != "undefined") && (dynamicData['Dynamic_BG'].length >= 1) && (key =="0") ){
				var cv_no = dynamicData['Dynamic_BG'][0]["Primary_Report"];
				console.log("dy_color_first");
				 for(i=0;i<= 3; i++){
					 var j=i+1;
					 document.getElementsByClassName("circle-"+j+"")[0].style.cssText += "background-color:"+dynamicData['Dynamic_BG'][0]["bg_color_"+i+""]+"";
				 }
				 document.getElementById("container").style.cssText += "color:" +dynamicData['Dynamic_BG'][0]["head_copy_color"]+"";
				 document.getElementById("cta").style.cssText += "background-color:"+ dynamicData['Dynamic_BG'][0]["cta_bg_color"]+"";
				 document.getElementById("pcta").style.cssText += "color:"+dynamicData['Dynamic_BG'][0]["cta_text_color"]+"";
				 document.getElementsByClassName("logo")[0].src = dynamicData['Dynamic_BG'][0]["logo_color"];
				 document.getElementsByClassName("prevButton")[0].src = dynamicData['Dynamic_BG'][0]["arrow_left"];
				 document.getElementsByClassName("nextButton")[0].src = dynamicData['Dynamic_BG'][0]["arrow_right"];
			}
				
				var cv_no = dynamicData['Dynamic_BG'][0]["Primary_Report"];
				var color_code = dynamicData['Dynamic_BG'][0]["bg_color_"+key+""]+"";
				var color_code_val = color_code;
				console.log(key,color_code,color_code_val,"val_check------");
				
                productReporting.push(result[key]['ID']);
				colorReporting.push(color_code_val);
				if(result[key]['model_type'] == "Footwear"){
					modeltypeReporting.push("FTW");
				}
				product_colorReporting.push(result[key]['ID']+":"+color_code_val);
				if(key == "0"){
					console.log("gender_coming_category_first_time");
					category_value = result[key]['Category'];
					gender_value = result[key]['Gender'];
				}
                var anchor = document.getElementsByClassName("slide-" + (parseInt(key) + 1))[0];
                var att = document.createAttribute("data-url");
                att.value = result[key]['URL'];
                anchor.setAttributeNode(att);
				
				var anchor_re = document.getElementsByClassName("slide-" + (parseInt(key) + 1))[0];
				var attVal = document.createAttribute("data-value");
				 attVal.value = customWidgetReporting+"-"+cv_no+"_"+productReporting[key]+":"+color_code_val;
                anchor_re.setAttributeNode(attVal);

                
                //resizeImage starts here
                var dbCont = result[key],
                	slideElem = document.getElementsByClassName("product")[key];;
                
                var imgWidth = parseInt(dbCont['width']),
					imgHeight = parseInt(dbCont['height']),
					imgTop = parseInt(dbCont['top_value']),
					imgBottom = parseInt(dbCont['bottom_value']),
					imgLeft = parseInt(dbCont['left_value']),
					imgRight = parseInt(dbCont['right_value']),
					imgTransparent = parseFloat(dbCont['Transparent_percent']);
		
				var productWidth = (imgWidth - (imgRight + imgLeft)),
					productHeight = (imgHeight - (imgTop + imgBottom));
				var unitWidth = dynamicData['campaignProperties:campaignProperties.creativeDim'].split('x')[0],
					unitHeight = dynamicData['campaignProperties:campaignProperties.creativeDim'].split('x')[1];
				
				slideElem.style.width = "auto";
				slideElem.style.height = (imageContainerHeight*imgHeight)/productHeight + "px";
			
					var elemWidth = slideElem.width;
					var rightTrans = ((imgRight * 100)/imgWidth);
					var croppedRight = ((rightTrans * elemWidth)/100);
					var leftTrans = ((imgLeft * 100)/imgWidth);
					var croppedLeft = ((leftTrans * elemWidth)/100);
					var actualWidth = (elemWidth - (croppedRight + croppedLeft));
			
				if( creativeDim == "300x250" || creativeDim == "120x600" || creativeDim == "250x250" || creativeDim == "300x300" || creativeDim == "300x600" || creativeDim == "160x600"){
					
					if(imageContainerWidth < actualWidth){
						slideElem.style.height = "auto";
						slideElem.style.width = (imageContainerWidth*imgWidth)/productWidth + "px";
						
					}
						var elemHeight = slideElem.height;
						var topTrans = ((imgTop * 100)/imgHeight);
						var croppedTop = ((topTrans * elemHeight)/100);
						var bottomTrans = ((imgBottom * 100)/imgHeight);
						var croppedBottom = ((bottomTrans * elemHeight)/100);
						var actualHeight = (elemHeight - (croppedTop + croppedBottom));
						if(actualHeight < actualHeightLess){
							var imageTop1 = setTop;
							if(creativeDim == "300x600"){
								slideElem.style.marginTop = (imageTop1 - croppedTop) + "px";
							}else{
								slideElem.style.top = (imageTop1 - croppedTop) + "px";
							}
						}else{
							if(creativeDim == "300x600"){
								slideElem.style.marginTop = (imageTop - croppedTop) + "px";
							}else{
								slideElem.style.top = (imageTop - croppedTop) + "px";
							}
						}
					
					if(creativeDim == "300x300" || creativeDim == "250x250" || creativeDim =="300x250"){
						slideElem.style.marginLeft = ((unitWidth - (slideElem.height)) / 2) + "px"; 
					}else if(creativeDim == "120x600" || creativeDim == "160x600"){
						if((navigator.userAgent.indexOf('Trident') != -1) || (navigator.userAgent.indexOf('Firefox') != -1)){
							var bottomFF = parseInt(slideElem.style.top) + 3;
							slideElem.style.top = bottomFF + "px";
						}
						slideElem.style.left = (((unitWidth - (slideElem.height)) / 2)-2) + "px"; 
					}else{
						if((navigator.userAgent.indexOf('Trident') != -1) || (navigator.userAgent.indexOf('Firefox') != -1)){
							var bottomFF = parseInt(slideElem.style.marginTop) + 3;
							slideElem.style.marginTop = bottomFF + "px";
						}
						slideElem.style.marginLeft = (((unitWidth - (slideElem.height)) / 2)-2) + "px"; 
					}
					slideElem.style.bottom = "auto";
				}else if(creativeDim == "320x50" || creativeDim == "970x250" || creativeDim =="728x90"){
					if(imageContainerWidth < actualWidth){
						//callResize();
						slideElem.style.height = "auto";
						slideElem.style.width = (imageContainerWidth*imgWidth)/productWidth + "px";
						var elemHeight = slideElem.height;
						var topTrans = ((imgTop * 100)/imgHeight);
						var croppedTop = ((topTrans * elemHeight)/100);
						var bottomTrans = ((imgBottom * 100)/imgHeight);
						var croppedBottom = ((bottomTrans * elemHeight)/100);
						var actualHeight = (elemHeight - (croppedTop + croppedBottom));
						if(creativeDim == "320x50"){
							var addBottom = (unitHeight - actualHeight)/2;
							slideElem.style.marginTop = (addBottom - croppedTop) + "px";
						}else if(creativeDim == "970x250"){
							var addTop = (unitHeight_1 - actualHeight)/2;
							slideElem.style.marginTop = (addTop - croppedTop) + "px";
						}else{
							var addBottom = (unitHeight - actualHeight)/2;
							slideElem.style.bottom = (addBottom - croppedBottom) + "px";
						}
					}else{
						var elemHeight = slideElem.height;
						var topTrans = ((imgTop * 100)/imgHeight);
						var croppedTop = ((topTrans * elemHeight)/100);
						var bottomTrans = ((imgBottom * 100)/imgHeight);
						var croppedBottom = ((bottomTrans * elemHeight)/100);
						if(creativeDim == "320x50"){
							slideElem.style.marginTop = (imageTop - croppedTop) + "px";
						}else if(creativeDim == "970x250"){
							slideElem.style.marginTop = (imageBottom - croppedTop) + "px";
						}else if(creativeDim == "728x90"){
							slideElem.style.bottom = (imageBottom - croppedBottom) + "px";
						}
					}
					var elemWidth = slideElem.height;
					var rightTrans = ((imgRight * 100)/imgWidth);
					var croppedRight = ((rightTrans * elemWidth)/100);
					var rightval = (imageRight - croppedRight) + "px";
					var leftTrans = ((imgLeft * 100)/imgWidth);
					var croppedLeft = ((leftTrans * elemWidth)/100);
					var actualWidth = (elemWidth - (croppedRight + croppedLeft));			
					var restWidth = imageContainerWidth - actualWidth;
					var addRight = restWidth / 2;
					if(creativeDim == "320x50"){
						slideElem.style.marginLeft = ((imageLeft - croppedRight) + addRight) + "px";
					}else if(creativeDim == "970x250"){
						slideElem.style.marginLeft = ((imageRight - croppedLeft) + addRight) + "px";
					}else{
						slideElem.style.right = ((imageRight - croppedRight) + addRight) + "px";
						slideElem.style.top = "auto";
					}
				}
			
            }
            //resizeImage ends here
            
            
            //reportingupdate
            console.log('###### reportingx : ', ap_geoLang+"-"+product_colorReporting.join('_'));
			console.log(priority,"priority_value_----------");
			if(priority == "RecentConverter"){
				strategy = "RETARGETING|RE-ENGAGEMENT";
				default_strategy = "NA|NA";
			}else if(priority == "Retargeting"){
				strategy = "RETARGETING|PDP";
				default_strategy = "NA|NA";
			}else if(priority == "HomepageTargeting"){
				strategy = "RETARGETING|HOMEPAGE";
				default_strategy = "NA|NA";
			}else if(priority == "AudienceId"){
				strategy = "RETARGETING|BEST_SELLER";
				default_strategy = "NA|NA";
			}else if(priority == "LineItemIds"){
				strategy = "PROSPECTING|BEST_SELLER";
				default_strategy = "NA|NA";
			}else if(priority == "GeoLanguageDefault"){
				strategy = "NA|NA";
				default_strategy = "DEFAULT|FALLBACK_DEFAULT";
			}else if(priority == "BaseDefault"){
				strategy = "NA|NA";
				default_strategy = "DEFAULT|MAIN_DEFAULT";
			}else{
				strategy = "NA|NA";
				default_strategy = "NA|NA";
			}
		
			if(ap_geoLang != "NA"){
				geoValue = ap_geoLang.split("_")[0].replace(" ","_");;
				langValue = ap_geoLang.split("_")[1];
			}else{
				geoValue = "NA";
				langValue = "NA";
			}
			var creativeTypeValue = {
				3:"Mobile_Standard",
				18:"IAB_Leaderboard",
				19:"IAB_Wide_Skyscraper",
				20:"IAB_Medium_Rectangle",
				21:"IAB_Rectangle",
				22:"IAB_Half Page",
				29:"IAB_Billboard_Non-Expanding"
			}
			
            var asv_values = {
				dspValue:"DBM",
				deviceValue:dynamicData['device:device.model'],
				creativeType:creativeTypeValue[creativeUnitType],
				creativeSize:dynamicData['campaignProperties:campaignProperties.creativeDim'],
				videoValue:"NA",
				dvLineitemID:dynamicData['tagVarService:tagVarService.DataSignal1'],
				dvAuctionID:dynamicData['tagVarService:tagVarService.DataSignal2'],
				dvCreativeID:ap_DataSignal3,
				dvSiteID:ap_DataSignal4,
				cmPID:"NA",
				cmAdID:"NA",
				cmRenderID:"NA",
				cmCreativeID:"NA",
				cmSiteID:"NA",
				otherDSPLineID:"NA",
				otherDSPAuctionID:"NA",
				otherDSPCreativeID:"NA",
				otherDSPRefsiteTag:"NA",
				otherDSPAID:"NA",
				dspProductModelType:"FTW",
				messageID:"NA",
				mindSetValue:"NA"
			}
		var assetVariantReportValues = strategy+"|"+geoValue+"|"+langValue+"|"+asv_values["dspValue"]+"|"+asv_values["deviceValue"]+"|"+asv_values["creativeType"]+"|"+asv_values["creativeSize"]+"|"+asv_values["videoValue"]+"|"+category_value+"|"+gender_value+"|"+asv_values["dvLineitemID"]+"|"+asv_values["dvAuctionID"]+"|"+asv_values["dvCreativeID"]+"|"+asv_values["dvSiteID"]+"|"+asv_values["cmPID"]+"|"+asv_values["cmAdID"]+"|"+asv_values["cmRenderID"]+"|"+asv_values["cmCreativeID"]+"|"+asv_values["cmSiteID"]+"|"+asv_values["otherDSPLineID"]+"|"+asv_values["otherDSPAuctionID"]+"|"+asv_values["otherDSPCreativeID"]+"|"+asv_values["otherDSPRefsiteTag"]+"|"+asv_values["otherDSPAID"]+"|"+productReporting.join(',')+"|"+colorReporting.join(",")+"|"+cv_no+"|"+asv_values["dspProductModelType"]+"|"+modeltypeReporting.join(",")+"|"+default_strategy+"|"+asv_values["messageID"]+"|"+asv_values["mindSetValue"];
			
            console.log('$$$$$$###########   creativeVariationReporting from argument : ', creativeVariationReporting);
            _jvxAd.recordAssetVariation("impression", assetVariantReportValues);
			
			var anchor_reAs = document.getElementsByClassName("slides-wrapper")[0];
				var attValAs = document.createAttribute("data-val");
				 attValAs.value = assetVariantReportValues;
                anchor_reAs.setAttributeNode(attValAs);
			
            
           
            	document.getElementsByClassName("slide")[0].style.cursor = "pointer"; 
            	document.getElementsByClassName("slide")[1].style.cursor = "pointer"; 
            	document.getElementsByClassName("slide")[2].style.cursor = "pointer"; 
            	document.getElementsByClassName("slide")[3].style.cursor = "pointer"; 
            
				
				
			
			if(priority == "LineItemIds" || priority == "GeoLanguageDefault" || priority == "BaseDefault"){
				if ((typeof dynamicData != "undefined") && (typeof dynamicData['Nike_Headlines'] != "undefined") && (dynamicData['Nike_Headlines'].length >= 1)){
					document.getElementById("pcta").innerHTML = dynamicData['Nike_Headlines'][0]['cta'];
				}
				if(widget.defaults.adSize == "300x250"){
				document.getElementsByClassName("head1")[0].innerHTML = result[0]['Frame_1'];
				if(result[0]['SpecialChar'] == "YES"){
                    if(result[0]['line_number'] == "3"){
                        document.getElementsByClassName("head1")[0].style.cssText += "top:10px;line-height:1.05;font-size:27px;";
                    }else{
                        document.getElementsByClassName("head1")[0].style.cssText += "top:28px;line-height:1.05;";
                    }
                }else if(result[0]['SpecialChar'] == "NO"){
                    if(result[0]['line_number'] == "2"){
                        document.getElementsByClassName("head1")[0].style.cssText += "top:38px";
                    }
                }
				if(navigator.userAgent.indexOf("Mac") > -1){
						document.getElementById("pcta").style.cssText += "margin-top:0px";
				}
				var headValText = document.getElementsByClassName("head1")[0].innerHTML;
				if( headValText =="DE<br>L'ENTRENAMENT<br>AL PARTIT" ){
					$(".head1").css('width',225);
				}	
				if(navigator.userAgent.indexOf("Win") > -1 && navigator.userAgent.indexOf("Firefox") > -1){
					$("#pcta").removeClass("autoresize");
					var cta = document.getElementById("pcta").innerHTML;
					document.getElementById("pcta").style.cssText += "font-size:12px";
				}
				
				if(navigator.userAgent.indexOf("Mac") > -1){
					if(navigator.userAgent.indexOf('Safari') != -1){
						document.getElementsByClassName("head1")[0].style.cssText += "padding-top:15px;";
						var topVal = 10;
						$(".head1").css('top',topVal-10);
					}
				}
				var headText = document.getElementsByClassName("head1")[0].innerHTML;
				if(navigator.userAgent.indexOf("Mac") > -1 && navigator.userAgent.indexOf("Firefox") > -1){
					if(headText == "ÉLÈVE<br>TON<br>JEU"){
						document.getElementsByClassName("head1")[0].style.cssText += "top:13px";
					}
				}
			
				}else if(widget.defaults.adSize == "250x250"){
					document.getElementsByClassName("head1")[0].innerHTML = result[0]['Frame_1'];
					if(result[0]['SpecialChar'] == "YES"){
						if(result[0]['line_number'] == "3"){
							document.getElementsByClassName("head1")[0].style.cssText += "top:10px;line-height:1.05;font-size:27px;";
						}else{
							document.getElementsByClassName("head1")[0].style.cssText += "top:24px;line-height:1.05;";
						}
					}else if(result[0]['SpecialChar'] == "NO"){
						if(result[0]['line_number'] == "2"){
							document.getElementsByClassName("head1")[0].style.cssText += "top:34px";
						}
					}
					var headValText = document.getElementsByClassName("head1")[0].innerHTML;
					if( headValText =="DE<br>L'ENTRENAMENT<br>AL PARTIT" ){
						$(".head1").css('top',22);
					}
					if(navigator.userAgent.indexOf("Win") > -1){
						  document.getElementById("pcta").style.cssText += "top:49%"
					}
					if(navigator.userAgent.indexOf("Win") > -1 && navigator.userAgent.indexOf("Firefox") > -1){
						$("#pcta").removeClass("autoresize");
						var cta = document.getElementById("pcta").innerHTML;
						document.getElementById("pcta").style.cssText += "font-size:12px";
					}
					if(navigator.userAgent.indexOf("Mac") > -1){
						if(navigator.userAgent.indexOf('Safari') != -1){
							document.getElementsByClassName("head1")[0].style.cssText += "padding-top:15px;";
							var topVal = 15;
							$(".head1").css('top',topVal-15);
						}
					}
				}else if(widget.defaults.adSize == "300x300"){
					document.getElementsByClassName("head1")[0].innerHTML = result[0]['Frame_1'];
					 if(result[0]['SpecialChar'] == "YES"){
						if(result[0]['line_number'] == "3"){
							document.getElementsByClassName("head1")[0].style.cssText += "top:13px;line-height:1.05;font-size: 29px;";
						}else{
							document.getElementsByClassName("head1")[0].style.cssText += "top:25px;line-height:1.05;";
						}
					}else if(result[0]['SpecialChar'] == "NO"){
						if(result[0]['line_number'] == "2"){
							document.getElementsByClassName("head1")[0].style.cssText += "top:38px";
						}
					}
					var headValText = document.getElementsByClassName("head1")[0].innerHTML;
					if( headValText =="DE<br>L'ENTRENAMENT<br>AL PARTIT" ){
						$(".head1").css('top',36);
					}
					if( headValText =="VELOCITAT<br>DE<br>GUANYADORS" ){
						$(".head1").css('top',22);
					}
					if(navigator.userAgent.indexOf("Win") > -1){
						  document.getElementById("pcta").style.cssText += "top:49%"
					}
					if(navigator.userAgent.indexOf("Win") > -1 && navigator.userAgent.indexOf("Firefox") > -1){
						$("#pcta").removeClass("autoresize");
						var cta = document.getElementById("pcta").innerHTML;
						var ctaLen = cta.length;
								if(ctaLen > 10){
									document.getElementById("pcta").style.cssText += "font-size:15px";
								}else{
									document.getElementById("pcta").style.cssText += "font-size:16px";
								}
					}
					if(navigator.userAgent.indexOf("Mac") > -1){
						if(navigator.userAgent.indexOf('Safari') != -1){
							document.getElementsByClassName("head1")[0].style.cssText += "padding-top:15px;";
							var topVal = 15;
							$(".head1").css('top',topVal-15);
						}
					}
				}else if(widget.defaults.adSize == "120x600"){
					if ((navigator.userAgent.indexOf('Trident') != -1)){
							document.getElementById("pcta").style.cssText += "margin-top:0px";
						}
					if(navigator.userAgent.indexOf("Mac") > -1){
						document.getElementById("pcta").style.cssText += "margin-top:1px";
					}
					document.getElementsByClassName("head1")[0].innerHTML = result[0]['Frame_1'];
					if(result[0]['SpecialChar'] == "YES"){
						if(result[0]['line_number'] == "3"){
							document.getElementsByClassName("head1")[0].style.cssText += "line-height:1.1;";
						}else{
							document.getElementsByClassName("head1")[0].style.cssText += "line-height:1.1;";
						}
					}else if(result[0]['SpecialChar'] == "NO"){
						if(result[0]['line_number'] == "2"){
						   // document.getElementsByClassName("head1")[0].style.cssText += "top:190px";
						}
					}
					if(navigator.userAgent.indexOf("Win") > -1 && navigator.userAgent.indexOf("Firefox") > -1){
						$("#pcta").removeClass("autoresize");
						var cta = document.getElementById("pcta").innerHTML;
						var ctaLen = cta.length;
						if(ctaLen > 10){
							document.getElementById("pcta").style.cssText += "font-size:15px";
						}else{
							document.getElementById("pcta").style.cssText += "font-size:17px";
						}
					}
					if(navigator.userAgent.indexOf("Mac") > -1){
						if(navigator.userAgent.indexOf('Safari') != -1){
							document.getElementsByClassName("head1")[0].style.cssText += "padding-top:8px;";
						}
					}
				}else if(widget.defaults.adSize == "160x600"){
					document.getElementsByClassName("head1")[0].innerHTML = result[0]['Frame_1'];
					if(result[0]['SpecialChar'] == "YES"){
						if(result[0]['line_number'] == "3"){
							document.getElementsByClassName("head1")[0].style.cssText += "top:164px;line-height:1.05;";
						}else{
							document.getElementsByClassName("head1")[0].style.cssText += "top:170px;line-height:1.05;";
						}
					}else if(result[0]['SpecialChar'] == "NO"){
						if(result[0]['line_number'] == "2"){
							document.getElementsByClassName("head1")[0].style.cssText += "top:178px";
						}
					}
					var headValText = document.getElementsByClassName("head1")[0].innerHTML;
					if( headValText =="LES<br>NOSTRES<br>SUPERVENDES" ){
						$(".head1").css('top',175);
					}
					if( headValText =="DE<br>L'ENTRENAMENT<br>AL PARTIT" ){
						$(".head1").css('top',186);
					}
					if( headValText =="DESAFIA<br>ELS TEUS<br>LÍMITS" ){
						$(".head1").css('top',168);
					}
					if( headValText =="VELOCITAT<br>DE<br>GUANYADORS" ){
						$(".head1").css('top',176);
					}
					if( headValText =="DESTACA<br>EL TEU<br>ESTIL" ){
						$(".head1").css('top',168);
					}
					if(navigator.userAgent.indexOf("Win") > -1 && navigator.userAgent.indexOf("Firefox") > -1){
						$("#pcta").removeClass("autoresize");
						var cta = document.getElementById("pcta").innerHTML;
						document.getElementById("pcta").style.cssText += "font-size:16px";
					}
					if(navigator.userAgent.indexOf("Mac") > -1){
						if(navigator.userAgent.indexOf('Safari') != -1){
							document.getElementsByClassName("head1")[0].style.cssText += "padding-top:15px;";
							var topVal = 163;
							$(".head1").css('top',topVal-15);
						}
					}
				}else if(widget.defaults.adSize == "300x600"){
					document.getElementsByClassName("head1")[0].innerHTML = result[0]['Frame_1'];
					if(result[0]['SpecialChar'] == "YES"){
						if(result[0]['line_number'] == "3"){
							document.getElementsByClassName("head1")[0].style.cssText += "top:130px;line-height:1.05;";
						}else{
							document.getElementsByClassName("head1")[0].style.cssText += "top:156px;line-height:1.05;";
						}
					}else if(result[0]['SpecialChar'] == "NO"){
						if(result[0]['line_number'] == "2"){
							document.getElementsByClassName("head1")[0].style.cssText += "top:170px";
						}
					}
					var headValText = document.getElementsByClassName("head1")[0].innerHTML;
					if( headValText =="DE<br>L'ENTRENAMENT<br>AL PARTIT" ){
						$(".head1").css('top',165);
					}
					if( headValText =="VELOCITAT<br>DE<br>GUANYADORS" ){
						$(".head1").css('top',148);
					}
					if( headValText =="LES<br>NOSTRES<br>SUPERVENDES" ){
						$(".head1").css('top',150);
					}
					if( headValText =="DESTACA<br>EL TEU<br>ESTIL" ){
						$(".head1").css('top',168);
					}
					if(navigator.userAgent.indexOf("Win") > -1 && navigator.userAgent.indexOf("Firefox") > -1){
						$("#pcta").removeClass("autoresize");
						var cta = document.getElementById("pcta").innerHTML;
						var ctaLen = cta.length;
						if(ctaLen > 10){
							document.getElementById("pcta").style.cssText += "font-size:15px";
						}else{
							document.getElementById("pcta").style.cssText += "font-size:16px";
						}
					}
					if(navigator.userAgent.indexOf("Win") > -1){
						document.getElementById("pcta").style.cssText += "height:19px;margin-top:1px";
					}
					if ((navigator.userAgent.indexOf('Trident') != -1) || (navigator.userAgent.indexOf("MSIE ") > -1)){
						 document.getElementById("pcta").style.cssText += "top:51%;";
					 }
					 if(navigator.userAgent.indexOf("Mac") > -1){
						if(navigator.userAgent.indexOf('Safari') != -1){
							document.getElementsByClassName("head1")[0].style.cssText += "padding-top:15px;";
							 var topVal = 135;
							$(".head1").css('top',topVal-15);
						}
					}
				}else if(widget.defaults.adSize == "320x50"){
					document.getElementsByClassName("head")[0].innerHTML = result[0]['Frame_2'];
					if(result[0]['SpecialChar_1'] == "YES"){
						document.getElementsByClassName("head")[0].style.cssText += "line-height:1.1;";
					}
					 if(navigator.userAgent.indexOf("Mac") > -1){
					 var elements = $( '.head');
						for(i=0;i<elements.length;i++){
							if(result[0]['SpecialChar_1'] == "YES"){
								$(".head")[i].style.cssText += "margin-top:3.5%";
							}else{
								$(".head")[i].style.cssText += "margin-top:2%";
							}
						}
					}
					if(navigator.userAgent.indexOf("Win") > -1 && navigator.userAgent.indexOf("Firefox") > -1){
						$("#pcta").removeClass("autoresize");
						var cta = document.getElementById("pcta").innerHTML;
						var ctaLen = cta.length;
						if(ctaLen > 10){
							document.getElementById("pcta").style.cssText += "font-size:8px";
						}else{
							document.getElementById("pcta").style.cssText += "font-size:10px";
						}
					}
					if(navigator.userAgent.indexOf("Mac") > -1 && !(navigator.userAgent.indexOf("Firefox") > -1)){
						document.getElementById("pcta").style.cssText += "margin-top:1px";
					}
					if(navigator.userAgent.indexOf("Mac") > -1){
						if(navigator.userAgent.indexOf('Safari') != -1){
							console.log("Mac_Safari");
							document.getElementsByClassName("heads")[0].style.cssText += "padding-top:15px;";
							var topVal = 5;
							$(".heads").css('top',topVal-15);
						}
					}
					
				}else if(widget.defaults.adSize == "728x90"){
					if ((navigator.userAgent.indexOf('Trident') != -1)){
						document.getElementById("pcta").style.cssText += "margin-top:0px";
					}
					if(navigator.userAgent.indexOf("Mac") > -1){
						document.getElementById("pcta").style.cssText += "margin-top:0px";
					}
					document.getElementsByClassName("head1")[0].innerHTML = result[0]['Frame_2'];
					if(result[0]['SpecialChar_1'] == "YES"){
						document.getElementsByClassName("head1")[0].style.cssText += "line-height:1";
					}
					var head1 = document.getElementsByClassName("head1")[0];
					if(head1.scrollHeight > 65){
						head1.style.cssText += "font-size:32px;line-height:0.82";
					}
					if(navigator.userAgent.indexOf("Win") > -1){
					  var cols = document.getElementsByClassName("head1");
						for(i=0; i<cols.length; i++) {
								cols[i].style.cssText += "top:44%";
						}
					}
					var headText = document.getElementsByClassName("head1")[0].innerHTML;
					if(headText == "ÉLÈVE<br>TON JEU"){
						document.getElementsByClassName("head1")[0].style.cssText += "top:49%";
					}
					if(headText == "DE L'ENTRENAMENT<br>AL PARTIT"){
						document.getElementsByClassName("heads")[0].style.cssText += "font-size:32px";
					}
					if(navigator.userAgent.indexOf("Win") > -1 && navigator.userAgent.indexOf("Firefox") > -1){
						$("#pcta").removeClass("autoresize");
						var cta = document.getElementById("pcta").innerHTML;
						document.getElementById("pcta").style.cssText += "font-size:12px";
					}
					
					if(navigator.userAgent.indexOf("Mac") > -1){
						if(navigator.userAgent.indexOf('Safari') != -1){
							document.getElementsByClassName("head1")[0].style.cssText += "padding-top:15px;";
							document.getElementsByClassName("head1")[0].style.cssText += "top:45%";
						}
						if(headText == "ÉLÈVE<br>TON JEU"){
							document.getElementsByClassName("head1")[0].style.cssText += "top:50%";
						}
					}
					if(navigator.userAgent.indexOf("Mac") > -1 && navigator.userAgent.indexOf("Firefox") > -1){
						if(headText == "ÉLÈVE<br>TON JEU"){
							document.getElementsByClassName("head1")[0].style.cssText += "top:54%";
						}
					}
				}else if(widget.defaults.adSize == "970x250"){
					document.getElementsByClassName("head1")[0].innerHTML = result[0]['Frame_2'];
					if(result[0]['SpecialChar_1'] == "YES"){
						document.getElementsByClassName("head1")[0].style.cssText += "line-height:1";
					}
					if(navigator.userAgent.indexOf("Win") > -1 && navigator.userAgent.indexOf("Firefox") > -1){
						$("#pcta").removeClass("autoresize");
						var cta = document.getElementById("pcta").innerHTML;
						document.getElementById("pcta").style.cssText += "font-size:18px";
					}
					if(navigator.userAgent.indexOf("Mac") > -1){
						if(navigator.userAgent.indexOf('Safari') != -1){
							document.getElementsByClassName("head1")[0].style.cssText += "padding-top:15px;";
							document.getElementsByClassName("head1")[0].style.cssText += "top:47%";
						}
					}
				}
				
				//Custom Event for Heading copies Prospecting
				if(widget.defaults.adSize != "320x50"){
					var headCopyPros = document.getElementsByClassName("head1")[0].innerHTML;
				}else{
					var headCopyPros = document.getElementsByClassName("head")[0].innerHTML;
				}
				
				if(headCopyPros == "undefined"){
					//console.log("Prospecting_Undefined");
					jvxAd.recordEventByName("Code27_Prospecting", 0);
					if( widget.defaults.adSize == "120x600" || widget.defaults.adSize == "160x600" || widget.defaults.adSize == "300x250" || widget.defaults.adSize == "250x250" || widget.defaults.adSize == "300x300" || widget.defaults.adSize == "300x600"){
						document.getElementsByClassName("head1")[0].innerHTML = "OUR<br>TOP<br>SELLERS";
					}else if(widget.defaults.adSize == "320x50"){
						document.getElementsByClassName("head")[0].innerHTML = "OUR TOP<br>SELLERS";
					}else{
						document.getElementsByClassName("head1")[0].innerHTML = "OUR TOP<br>SELLERS";
					}
				}
				setTimeout(function(){
					console.log("comming-------2");
					startAllPros();            		
				}, 2e3);
			}else{
			
			var creativeDim = dynamicData['campaignProperties:campaignProperties.creativeDim'];
			if( creativeDim == "120x600" || creativeDim == "160x600" || creativeDim == "300x250" || creativeDim == "250x250" || creativeDim == "300x300" || creativeDim == "300x600"){
				document.getElementsByClassName("head")[0].innerHTML = dynamicData['Nike_Headlines'][0]['Frame1'];
				document.getElementsByClassName("head")[1].innerHTML = dynamicData['Nike_Headlines'][0]['Frame2'];
				document.getElementsByClassName("head")[2].innerHTML = dynamicData['Nike_Headlines'][0]['Frame3'];
				document.getElementsByClassName("head")[3].innerHTML = dynamicData['Nike_Headlines'][0]['Frame4'];
			}else{
				document.getElementsByClassName("head")[0].innerHTML = dynamicData['Nike_Headlines'][0]['Frame5'];
				document.getElementsByClassName("head")[1].innerHTML = dynamicData['Nike_Headlines'][0]['Frame6'];
				document.getElementsByClassName("head")[2].innerHTML = dynamicData['Nike_Headlines'][0]['Frame7'];
				document.getElementsByClassName("head")[3].innerHTML = dynamicData['Nike_Headlines'][0]['Frame8'];
			}
            document.getElementById("pcta").innerHTML = dynamicData['Nike_Headlines'][0]['cta'];
			
				if(creativeDim == "300x250"){
					if(dynamicData['Nike_Headlines'][0]['Special_Character'] == "YES"){
						var indexVal = dynamicData['Nike_Headlines'][0]['SC_Index'];
						if(indexVal.length > 1){
							var inVal = indexVal.split(",");
							for(i=0; i< inVal.length ; i++){
								document.getElementsByClassName("head")[inVal[i]].style.cssText += "top:10px;line-height:1.05;font-size:27px;";
							}
						}else{
							document.getElementsByClassName("head")[indexVal].style.cssText += "top:10px;line-height:1.05;font-size:27px;";
						}
					}
				if(navigator.userAgent.indexOf("Mac") > -1){
					document.getElementById("pcta").style.cssText += "margin-top:0px";
				}
				if(navigator.userAgent.indexOf("Win") > -1 && navigator.userAgent.indexOf("Firefox") > -1){
					$("#pcta").removeClass("autoresize");
					var cta = document.getElementById("pcta").innerHTML;
					document.getElementById("pcta").style.cssText += "font-size:12px";
				}
				}
				if(creativeDim == "120x600"){
					if ((navigator.userAgent.indexOf('Trident') != -1)){
							document.getElementById("pcta").style.cssText += "margin-top:0px";
						}
					if(navigator.userAgent.indexOf("Mac") > -1){
						document.getElementById("pcta").style.cssText += "margin-top:1px";
					}
					if(dynamicData['Nike_Headlines'][0]['Special_Character'] == "YES"){
						var indexVal = dynamicData['Nike_Headlines'][0]['SC_Index'];
						if(indexVal.length > 1){
							var inVal = indexVal.split(",");
							for(i=0; i< inVal.length ; i++){
								document.getElementsByClassName("head")[inVal[i]].style.cssText += "top:191px;line-height:1.1;";
							}
						}else{
							document.getElementsByClassName("head")[indexVal].style.cssText += "top:191px;line-height:1.1;";
						}
					}
					if(document.getElementsByClassName("head")[1].innerHTML == "DEVOLUCIONS<br>GRATUÏTES<br>DURANT 30 DIES"){
						document.getElementsByClassName("head")[1].style.cssText += "font-size:15px;top:195px;";
						document.getElementsByClassName("head")[3].style.cssText += "font-size:15px;top:195px;";
					}
					if(navigator.userAgent.indexOf("Win") > -1 && navigator.userAgent.indexOf("Firefox") > -1){
						$("#pcta").removeClass("autoresize");
						var cta = document.getElementById("pcta").innerHTML;
						var ctaLen = cta.length;
						if(ctaLen > 10){
							document.getElementById("pcta").style.cssText += "font-size:15px";
						}else{
							document.getElementById("pcta").style.cssText += "font-size:17px";
						}
					}
				}
				if(creativeDim == "160x600"){
					if(dynamicData['Nike_Headlines'][0]['Special_Character'] == "YES"){
						var indexVal = dynamicData['Nike_Headlines'][0]['SC_Index'];
						if(indexVal.length > 1){
							var inVal = indexVal.split(",");
							for(i=0; i< inVal.length ; i++){
								document.getElementsByClassName("head")[inVal[i]].style.cssText += "top:164px;line-height:1.05;";
							}
						}else{
							document.getElementsByClassName("head")[indexVal].style.cssText += "top:164px;line-height:1.05;";
						}
					}
					if(document.getElementsByClassName("head")[1].innerHTML == "DEVOLUCIONS<br>GRATUÏTES<br>DURANT 30 DIES"){
						document.getElementsByClassName("head")[1].style.cssText += "top:171px;";
						document.getElementsByClassName("head")[3].style.cssText += "top:171px;";
					}
					if(navigator.userAgent.indexOf("Win") > -1 && navigator.userAgent.indexOf("Firefox") > -1){
						$("#pcta").removeClass("autoresize");
						var cta = document.getElementById("pcta").innerHTML;
						var ctaLen = cta.length;
							document.getElementById("pcta").style.cssText += "font-size:16px";
					}
				}
				if(creativeDim == "250x250"){
					if(dynamicData['Nike_Headlines'][0]['Special_Character'] == "YES"){
					var indexVal = dynamicData['Nike_Headlines'][0]['SC_Index'];
					if(indexVal.length > 1){
						var inVal = indexVal.split(",");
						for(i=0; i< inVal.length ; i++){
							document.getElementsByClassName("head")[inVal[i]].style.cssText += "top:10px;line-height:1.05;font-size:27px;";
						}
					}else{
						document.getElementsByClassName("head")[indexVal].style.cssText += "top:10px;line-height:1.05;font-size:27px;";
					}
					}
					if(navigator.userAgent.indexOf("Win") > -1){
						  document.getElementById("pcta").style.cssText += "top:49%"
					}
					if(navigator.userAgent.indexOf("Win") > -1 && navigator.userAgent.indexOf("Firefox") > -1){
						$("#pcta").removeClass("autoresize");
						var cta = document.getElementById("pcta").innerHTML;
						var ctaLen = cta.length;
							document.getElementById("pcta").style.cssText += "font-size:12px";
					}
				}
				if(creativeDim == "300x300"){
					if(dynamicData['Nike_Headlines'][0]['Special_Character'] == "YES"){
					var indexVal = dynamicData['Nike_Headlines'][0]['SC_Index'];
					if(indexVal.length > 1){
						var inVal = indexVal.split(",");
						for(i=0; i< inVal.length ; i++){
							document.getElementsByClassName("head")[inVal[i]].style.cssText += "top:13px;line-height:1.05;font-size: 29px;";
						}
					}else{
						document.getElementsByClassName("head")[indexVal].style.cssText += "top:13px;line-height:1.05;font-size: 29px;";
					}
					
				}
					if(navigator.userAgent.indexOf("Win") > -1){
						  document.getElementById("pcta").style.cssText += "top:49%"
					}
					if(navigator.userAgent.indexOf("Win") > -1 && navigator.userAgent.indexOf("Firefox") > -1){
						$("#pcta").removeClass("autoresize");
						var cta = document.getElementById("pcta").innerHTML;
						var ctaLen = cta.length;
						if(ctaLen > 10){
							document.getElementById("pcta").style.cssText += "font-size:15px";
						}else{
							document.getElementById("pcta").style.cssText += "font-size:16px";
						}
					}
				}
				if(creativeDim == "300x600"){
					if(dynamicData['Nike_Headlines'][0]['Special_Character'] == "YES"){
						var indexVal = dynamicData['Nike_Headlines'][0]['SC_Index'];
						if(indexVal.length > 1){
							var inVal = indexVal.split(",");
							for(i=0; i< inVal.length ; i++){
								document.getElementsByClassName("head")[inVal[i]].style.cssText += "top:130px;line-height:1.05;";
							}
						}else{
							document.getElementsByClassName("head")[indexVal].style.cssText += "top:130px;line-height:1.05;";
						}
					}
					if(document.getElementsByClassName("head")[1].innerHTML == "DEVOLUCIONS<br>GRATUÏTES<br>DURANT 30 DIES"){
						document.getElementsByClassName("head")[1].style.cssText += "top:148px;";
						document.getElementsByClassName("head")[3].style.cssText += "top:148px;";
					}
					if(navigator.userAgent.indexOf("Win") > -1 && navigator.userAgent.indexOf("Firefox") > -1){
						$("#pcta").removeClass("autoresize");
						var cta = document.getElementById("pcta").innerHTML;
						var ctaLen = cta.length;
						if(ctaLen > 10){
							document.getElementById("pcta").style.cssText += "font-size:15px";
						}else{
							document.getElementById("pcta").style.cssText += "font-size:16px";
						}
					}
					if(navigator.userAgent.indexOf("Win") > -1){
						document.getElementById("pcta").style.cssText += "height:19px;margin-top:1px";
					}
					if ((navigator.userAgent.indexOf('Trident') != -1) || (navigator.userAgent.indexOf("MSIE ") > -1)){
						 document.getElementById("pcta").style.cssText += "top:51%;";
					}
				}
				if(creativeDim == "320x50"){
					if(dynamicData['Nike_Headlines'][0]['Special_Character_1'] == "YES"){
						var indexVal = dynamicData['Nike_Headlines'][0]['SC_Index_1'];
						if(indexVal.length > 1){
							var inVal = indexVal.split(",");
							for(i=0; i< inVal.length ; i++){
								document.getElementsByClassName("head")[inVal[i]].style.cssText += "line-height:1.1;";
							}
						}else{
							document.getElementsByClassName("head")[indexVal].style.cssText += "line-height:1.1;";
						}
					}
					if(document.getElementsByClassName("head")[2].innerHTML == "DOSTĘPNA OPCJA<br>KLIKNIJ I ODBIERZ"){
						document.getElementsByClassName("head")[2].style.cssText += "line-height:1.1;";	
					}
					if(navigator.userAgent.indexOf("Mac") > -1){
						 var elements = $( '.head');
							for(i=0;i<elements.length;i++){
								if(dynamicData['Nike_Headlines'][0]['Special_Character_1'] == "YES"){
									$(".head")[i].style.cssText += "margin-top:3.5%";
								}else{
									$(".head")[i].style.cssText += "margin-top:2%";
								}
							}
					 }
					 if(navigator.userAgent.indexOf("Win") > -1 && navigator.userAgent.indexOf("Firefox") > -1){
						$("#pcta").removeClass("autoresize");
						var cta = document.getElementById("pcta").innerHTML;
						var ctaLen = cta.length;
						if(ctaLen > 10){
							document.getElementById("pcta").style.cssText += "font-size:8px";
						}else{
							document.getElementById("pcta").style.cssText += "font-size:10px";
						}
					}
					if(navigator.userAgent.indexOf("Mac") > -1 && !(navigator.userAgent.indexOf("Firefox") > -1)){
						document.getElementById("pcta").style.cssText += "margin-top:1px";
					}
					
				}
				if(creativeDim == "728x90"){
					if ((navigator.userAgent.indexOf('Trident') != -1)){
						document.getElementById("pcta").style.cssText += "margin-top:0px";
					}
					if(navigator.userAgent.indexOf("Mac") > -1){
						document.getElementById("pcta").style.cssText += "margin-top:0px";
					}
					var head1 = $( '.head' )[0],
					head2 = $( '.head' )[1],
					head3 = $( '.head' )[2],
					head4 = $( '.head' )[3];
					
					
					 if(head1.scrollHeight > 65){
						head1.style.cssText += "font-size:32px;line-height:0.82";
					}
					 if(head2.scrollHeight > 65){
						head2.style.cssText += "font-size:32px;line-height:0.82";
					}
					 if(head3.scrollHeight > 65){
						head3.style.cssText += "font-size:32px;line-height:0.82";
					}
					 if(head4.scrollHeight > 65){
						head4.style.cssText += "font-size:32px;line-height:0.82";
					}
					
					if(head1.innerHTML == "DEVOLUCIONES GRATUITAS<br>POR 30 DÍAS"){
						head1.style.cssText += "font-size:25px";
						head3.style.cssText += "font-size:25px";
					}
					if(head2.innerHTML == "30 TAGE KOSTENLOSE<br>RÜCKGABE"){
						head2.style.cssText += "font-size:30px";
						head4.style.cssText += "font-size:30px";
					}
					if(head3.innerHTML == "DOSTĘPNA OPCJA<br>KLIKNIJ I ODBIERZ"){
						head3.style.cssText +="line-height:1.1";
					}
					if(head3.innerHTML == "CLICK &amp; COLLECT-<br>LEVERANS TILLGÄNGLIG"){
						console.log("coming_sweedan");
						head3.style.cssText += "font-size:28px;line-height:1.1";
					}
					if(head2.innerHTML == "DEVOLUCIONS GRATUÏTES<br>DURANT 30 DIES"){
						document.getElementsByClassName("head")[1].style.cssText += "font-size:26px;";
						document.getElementsByClassName("head")[3].style.cssText += "font-size:26px;";
					}
					if(head3.innerHTML == "LLIURAMENT CLICK AND<br>COLLECT DISPONIBLE"){
						document.getElementsByClassName("head")[2].style.cssText += "font-size:27px;";
					}
					if(dynamicData['Nike_Headlines'][0]['Special_Character_1'] == "YES"){
						var indexVal = dynamicData['Nike_Headlines'][0]['SC_Index_1'];
						if(indexVal.length > 1){
							var inVal = indexVal.split(",");
							for(i=0; i< inVal.length ; i++){
								document.getElementsByClassName("head")[inVal[i]].style.cssText += "line-height:1;";
							}
						}else{
							document.getElementsByClassName("head")[indexVal].style.cssText += "line-height:1;";
						}
					}
					if(navigator.userAgent.indexOf("Mac") > -1){
						if(document.getElementsByClassName("head")[1].innerHTML == "30 TAGE KOSTENLOSE<br>RÜCKGABE"){
							document.getElementsByClassName("head")[1].style.cssText += "line-height:1.05;";
							document.getElementsByClassName("head")[3].style.cssText += "line-height:1.05;";
						}
						if(document.getElementsByClassName("head")[2].innerHTML == "CLICK &amp; COLLECT<br>LIEFERUNG MÖGLICH"){
							document.getElementsByClassName("head")[2].style.cssText += "line-height:1.1;";
						}
					}
					if(navigator.userAgent.indexOf("Win") > -1){
					  var cols = document.getElementsByClassName("head");
						for(i=0; i<cols.length; i++) {
								cols[i].style.cssText += "top:44%";
						}
					}
					if(navigator.userAgent.indexOf("Win") > -1 && navigator.userAgent.indexOf("Firefox") > -1){
						$("#pcta").removeClass("autoresize");
						var cta = document.getElementById("pcta").innerHTML;
						var ctaLen = cta.length;
							document.getElementById("pcta").style.cssText += "font-size:12px";
					}
				}
				if(creativeDim == "970x250"){
					var head1 = $( '.head' )[0],
					head2 = $( '.head' )[1],
					head3 = $( '.head' )[2],
					head4 = $( '.head' )[3];
					if(head1.scrollHeight > 150){
						head1.style.cssText += "font-size:54px";
					}
					if(head2.scrollHeight > 150){
						head2.style.cssText += "font-size:54px";
					}
					if(head3.scrollHeight > 150){
						head3.style.cssText += "font-size:54px";
					}
					if(head4.scrollHeight > 150){
						head4.style.cssText += "font-size:54px";
					}
					var elementsVal = $('.head');
					for(i=0;i<elementsVal.length;i++){
						var elementsText = elementsVal[i].innerHTML;
						if(elementsText.length >= 30){
							elementsVal[i].style.cssText += "font-size:52px";
						}
					}
					
					if(dynamicData['Nike_Headlines'][0]['Special_Character_1'] == "YES"){
						var indexVal = dynamicData['Nike_Headlines'][0]['SC_Index_1'];
						if(indexVal.length > 1){
							var inVal = indexVal.split(",");
							for(i=0; i< inVal.length ; i++){
								document.getElementsByClassName("head")[inVal[i]].style.cssText += "line-height:1.05;";
							}
						}else{
							document.getElementsByClassName("head")[indexVal].style.cssText += "line-height:1.05;";
						}
					}
					
					if(head1.innerHTML == "DEVOLUCIONES GRATUITAS<br>POR 30 DÍAS"){
						head1.style.cssText +="font-size:45px";
						head3.style.cssText +="font-size:45px";
					}
					if(head3.innerHTML == "CLICK &amp; COLLECT-<br>LEVERANS TILLGÄNGLIG"){
						head3.style.cssText +="font-size:48px;line-height:1.1";
					}
					if(head3.innerHTML == "DOSTĘPNA OPCJA<br>KLIKNIJ I ODBIERZ"){
						head3.style.cssText +="line-height:1.1";
					}
					if(navigator.userAgent.indexOf("Win") > -1 && navigator.userAgent.indexOf("Firefox") > -1){
						$("#pcta").removeClass("autoresize");
						var cta = document.getElementById("pcta").innerHTML;
						var ctaLen = cta.length;
							document.getElementById("pcta").style.cssText += "font-size:18px";
					}
					
				}
				//Custom Event for Heading copies Retargeting
				var headCopy1 = document.getElementsByClassName("head")[0].innerHTML,
					headCopy2 = document.getElementsByClassName("head")[1].innerHTML,
					headCopy3 = document.getElementsByClassName("head")[2].innerHTML,
					headCopy4 = document.getElementsByClassName("head")[3].innerHTML;
				if(headCopy1 == "undefined" || headCopy2 == "undefined" || headCopy3 == "undefined" || headCopy4 == "undefined"){
					//console.log("Retargeting_Undefined");
					jvxAd.recordEventByName("Code27_Retargeting", 0);
					if( creativeDim == "120x600" || creativeDim == "160x600" || creativeDim == "300x250" || creativeDim == "250x250" || creativeDim == "300x300" || creativeDim == "300x600"){
						if(headCopy1 == "undefined"){
							document.getElementsByClassName("head")[0].innerHTML = "FREE<br>STANDARD<br>DELIVERY";
						}
						if(headCopy2 == "undefined"){
							document.getElementsByClassName("head")[1].innerHTML = "FREE<br>30-DAY<br>RETURNS";
						}
						if(headCopy3 == "undefined"){
							document.getElementsByClassName("head")[2].innerHTML = "CLICK &<br>COLLECT<br>DELIVERY";
						}
						if(headCopy4 == "undefined"){
							document.getElementsByClassName("head")[3].innerHTML = "FREE<br>30-DAY<br>RETURNS";
						}
					}else{
						if(headCopy1 == "undefined"){
							document.getElementsByClassName("head")[0].innerHTML = "FREE<br>DELIVERY";
						}
						if(headCopy2 == "undefined"){
							document.getElementsByClassName("head")[1].innerHTML = "FREE 30-DAY<br>RETURNS";
						}
						if(headCopy3 == "undefined"){
							document.getElementsByClassName("head")[2].innerHTML = "CLICK AND COLLECT<br>DELIVERY AVAILABLE";
						}
						if(headCopy4 == "undefined"){
							document.getElementsByClassName("head")[3].innerHTML = "FREE 30-DAY<br>RETURNS";
						}
					}
				}
				
            setTimeout(function(){
				console.log("comming-------1");
            	startAll();            		
            }, 2e3);
			}
            console.log('Last : ################# 2e3');
        };

        this.getCatogoryProducts = function(result) {
            console.log("CatogoryProducts : ", result, result['g_l_g-c:g_l_g-c'].length);
            if (result['g_l_g-c:g_l_g-c'].length >= widget.defaults.numberOfProducts) { // wips changed
                result = result[Object.keys(result)[0]];
                console.log('CatogoryProducts2 result : ', result);
                for (var key in result) {
                    productSet.push(result[key]);
                }
                //console.log('productSetCat : ',productSet, productSet.slice(0, 4), productSet.length, typeof productSet); 
                self.generateGallery(productSet.slice(0, widget.defaults.numberOfProducts),"Retargeting"+"_"+ap_geoLang,"Retargeting"+"_"+ap_geoLang)
            } else {
                console.log("Invalid cat");
                self.callGeoLangDefaults(ap_geoLang + "_default");
            }
        }
        this.getProductIds = function(result) {
            if (result['g_l_pid:g_l_pid'].length > 0) {
                console.log('Products length', result, result['g_l_pid:g_l_pid'].length);
                result = result[Object.keys(result)[0]];
                console.log('result : ', result);
                for (var key in result) {
                    productSet.push(result[key]);
                }
                console.log('productSet : ', productSet, productSet.length, widget.defaults.numberOfProducts);
				
				if(productSet.length == widget.defaults.numberOfProducts){ //wips changed
					self.generateGallery(productSet.slice(0, widget.defaults.numberOfProducts),"Retargeting"+"_"+ap_geoLang,"Retargeting"+"_"+ap_geoLang);
				}else if ((productSet.length < widget.defaults.numberOfProducts) && (productSet.length !== 0)) {
                  
                    productSet.forEach(function(element) {
                        getCatagory.unshift(element['Category']);
                        getGender.unshift(element['Gender']);
                        //productIds.push(ap_geoLang+"_"+element);
                    });
                    //call category
                    var maxGen = arrayMaxRepeat(getGender).toLowerCase(),
                        maxCat = arrayMaxRepeat(getCatagory).toLowerCase();
                    self.dynamicDataCallback("g_l_g-c", ap_geoLang + "_" + maxGen + "_" + maxCat, "getCatogoryProducts"); //wip

                }
                console.log("CatGen : ", getCatagory, getGender, maxGen, maxCat);
                
            }else if ((ap_geoLang !== "NA_NA")&& (typeof dynamicData != "undefined") && (typeof dynamicData['aid_report_B3'] != "undefined") && (dynamicData['aid_report_B3'].length >= 1) && (dynamicData['aid_report_B3'][0]['Reporting'] != "No Audience ID")) { //Audience catagory Id via DS2 (Feed) - Priority 2 
                console.log('Audience Id available | Priority 2', dynamicData['aid_report_B3'][0]['Reporting']);
                var dspDS2 = dynamicData['aid_report_B3'][0]['Reporting'];
				console.log(dspDS2,"dspDS2");
                self.validateAudienceId(dspDS2);
            }else if ((self.getDynamicData('tagVarService:tagVarService.DataSignal1')) && (ap_geoLang !== "NA_NA")) { //wips changed
               console.log('getaudienceSetx has lesser result');
                var dspDS1 = self.getDynamicData('tagVarService:tagVarService.DataSignal1');
                self.validateDSPId(dspDS1);
            } else{
				console.log("call_default");
				 self.callGeoLangDefaults(ap_geoLang + "_default");
			}
        }
        this.getDSPCatProducts = function(result) {
            if (result['g_l_c:g_l_c'].length >= widget.defaults.numberOfProducts) {
                console.log('getDSPCatProductsz : ', result, result['g_l_c:g_l_c']);

                result = result[Object.keys(result)[0]];
                console.log('getDSPCatProducts result : ', result);
                for (var key in result) {
                    productSet.push(result[key]);
                }
               console.log('productSetCat : ',productSet, productSet.slice(0, 4), productSet.length, typeof productSet); 
                
                self.generateGallery(productSet.slice(0, widget.defaults.numberOfProducts),"LineItemIds_"+result[0]['Category'].toLowerCase()+"_"+ap_geoLang+"-"+ap_DataSignal1,"LineItemIds_"+result[0]['Category'].toLowerCase()+"_"+ap_geoLang); 
            } else {
                self.callGeoLangDefaults(ap_geoLang + "_default");
            }
        }
		this.getConverterCatProducts = function(result) {
            if (result['g_l_c:g_l_c'].length >= widget.defaults.numberOfProducts) {
                console.log('getConverterCatProductsz : ', result, result['g_l_c:g_l_c']);
                result = result[Object.keys(result)[0]];
                console.log('getConverterCatProducts result : ', result);
                for (var key in result) {
                    productSet.push(result[key]);
                }
               console.log('productSetConverterCat : ',productSet, productSet.slice(0, 4), productSet.length, typeof productSet); 
                self.generateGallery(productSet.slice(0, widget.defaults.numberOfProducts),"RecentConverter_"+result[0]['Category'].toLowerCase()+"_"+ap_geoLang+"-"+ap_DataSignal1,"RecentConverter_"+result[0]['Category'].toLowerCase()+"_"+ap_geoLang); 
            } else if ((self.isRetargeting()) && (ap_geoLang !== "NA_NA") && (self.getDynamicData('cookieData:cookieData.jvxdynsl_group1'))) { //Retargeting - Priority 1 // && (1==2)
                console.log('isRetargeting | Priority 1 ');
                var cookieValG1 = self.getDynamicData('cookieData:cookieData.jvxdynsl_group1');
                self.validateRetargetingProducts(cookieValG1);
            }else if ((ap_geoLang !== "NA_NA")&& (typeof dynamicData != "undefined") && (typeof dynamicData['aid_report_B3'] != "undefined") && (dynamicData['aid_report_B3'].length >= 1) && (dynamicData['aid_report_B3'][0]['Reporting'] != "No Audience ID")) { //Audience catagory Id via DS2 (Feed) - Priority 2 
                console.log('Audience Id available | Priority 2', dynamicData['aid_report_B3'][0]['Reporting']);
                var dspDS2 = dynamicData['aid_report_B3'][0]['Reporting'];
				console.log(dspDS2,"dspDS2");
                self.validateAudienceId(dspDS2);
            }else if ((self.getDynamicData('tagVarService:tagVarService.DataSignal1')) && (ap_geoLang !== "NA_NA")) { //Prospecting DCM Id via DS1 (Google sheet) - Priority 3
                console.log('Prospecting DCM Id available | Priority 3', self.getDynamicData('tagVarService:tagVarService.DataSignal1'));
                var dspDS1 = self.getDynamicData('tagVarService:tagVarService.DataSignal1');
                self.validateDSPId(dspDS1);
            }
			else if ((ap_geoLang !== "NA_NA")) { //Default - Geo_Lang Default - Priority 4
                console.log('ap_geoLang matching | Priority 4', ap_geoLang);
                self.callGeoLangDefaults(ap_geoLang + "_default");
            }else { //Default - Universal Default - Priority 5 UK
                console.log('Base default loaded | Priority 5');
                //self.loadDefault();
                self.dynamicDataCallback("Nike_Defaults", "_default_", "loadDefault");
            }
        }
        
        this.getaudienceSet = function(result) {
            console.log('getaudienceSetz : ', result, result['g_l_aid:g_l_aid'].length);
            if (result['g_l_aid:g_l_aid'].length >= widget.defaults.numberOfProducts) {
                result = result[Object.keys(result)[0]];
                console.log('getaudienceSetx result : ', result);
                for (var key in result) {
                    productSet.push(result[key]);
                }
                var aid_value = dynamicData['aid_report_B3'][0]['Reporting'];
				console.log(aid_value,"DS2_Val");
				if(aid_value == "172846969" || aid_value == "245899369" || aid_value == "259539049"){
					var audienceIdReport = "HomepageTargeting_";
				}else{
					var audienceIdReport = "AudienceId_";
				}
                self.generateGallery(productSet.slice(0, widget.defaults.numberOfProducts),audienceIdReport+result[0]['Gender'].toLowerCase()+"_"+result[0]['model_type'].toLowerCase()+"_"+result[0]['Category'].toLowerCase()+"_"+ap_geoLang+"-"+ap_DataSignal1,audienceIdReport+result[0]['Gender'].toLowerCase()+"_"+result[0]['model_type'].toLowerCase()+"_"+result[0]['Category'].toLowerCase()+"_"+ap_geoLang)
                
            } else if ((self.getDynamicData('tagVarService:tagVarService.DataSignal1'))  && (ap_geoLang !== "NA_NA")) { //wips changed
                console.log('getaudienceSetx has lesser result');
                var dspDS1 = self.getDynamicData('tagVarService:tagVarService.DataSignal1');
                self.validateDSPId(dspDS1);
            } else{
				console.log("call_for_default_no_match");
				 self.callGeoLangDefaults(ap_geoLang + "_default");
			}
			
        }
        this.getConverterCat = function(result) {
			console.log("getConverterId");
            console.log('getConverterCat : ', result, result['line_items_id:line_items_id'].length);
            if (result['line_items_id:line_items_id'].length >= 1) {
                var catDBConverter = ap_geoLang + "_" + result['line_items_id:line_items_id'][0]['category'].toLowerCase();
                self.dynamicDataCallback("g_l_c", catDBConverter, "getConverterCatProducts");
            } else if ((self.isRetargeting()) && (ap_geoLang !== "NA_NA") && (self.getDynamicData('cookieData:cookieData.jvxdynsl_group1'))) { //Retargeting - Priority 1 // && (1==2)
                console.log('isRetargeting | Priority 1 ');
                var cookieValG1 = self.getDynamicData('cookieData:cookieData.jvxdynsl_group1');
                self.validateRetargetingProducts(cookieValG1)
            } else if ((ap_geoLang !== "NA_NA")&& (typeof dynamicData != "undefined") && (typeof dynamicData['aid_report_B3'] != "undefined") && (dynamicData['aid_report_B3'].length >= 1) && (dynamicData['aid_report_B3'][0]['Reporting'] != "No Audience ID")) { //Audience catagory Id via DS2 (Feed) - Priority 2 
                console.log('Audience Id available | Priority 2', dynamicData['aid_report_B3'][0]['Reporting']);
                var dspDS2 = dynamicData['aid_report_B3'][0]['Reporting'];
				console.log(dspDS2,"dspDS2");
                self.validateAudienceId(dspDS2);
            }else if ((self.getDynamicData('tagVarService:tagVarService.DataSignal1')) && (ap_geoLang !== "NA_NA")) { //Prospecting DCM Id via DS1 (Google sheet) - Priority 3
                console.log('Prospecting DCM Id available | Priority 3', self.getDynamicData('tagVarService:tagVarService.DataSignal1'));
                var dspDS1 = self.getDynamicData('tagVarService:tagVarService.DataSignal1');
                self.validateDSPId(dspDS1);
            }
			else if ((ap_geoLang !== "NA_NA")) { //Default - Geo_Lang Default - Priority 4
                console.log('ap_geoLang matching | Priority 4', ap_geoLang);
                self.callGeoLangDefaults(ap_geoLang + "_default");
            } else { //Default - Universal Default - Priority 5 UK
                console.log('Base default loaded | Priority 5');
                //self.loadDefault();
                self.dynamicDataCallback("Nike_Defaults", "_default_", "loadDefault");
            }
        }
		this.getDSPCat = function(result) {
			console.log("getDSP");
            console.log('getDSPCat : ', result, result['line_items_id:line_items_id'].length);
            if (result['line_items_id:line_items_id'].length >= 1) {
				if(ap_bestsellerID == "bestseller"){
					console.log("BestSeller_Logic_ID",ap_bestsellerID);
					var catDBTrigger = ap_geoLang + "_" + result['line_items_id:line_items_id'][0]['category'].toLowerCase()+ "_bestseller";
				}else{
					var catDBTrigger = ap_geoLang + "_" + result['line_items_id:line_items_id'][0]['category'].toLowerCase();
				}
               // console.log('catDBTrigger : ', catDBTrigger);
                self.dynamicDataCallback("g_l_c", catDBTrigger, "getDSPCatProducts");
            } else {
                console.log('Not valid DSP');
                self.callGeoLangDefaults(ap_geoLang + "_default");
            }
        }
        this.getGeoLangDefaults = function(result) {
            console.log('getGeoLangDefaultsz : ', result, result['Nike_Defaults:Nike_Defaults'], result['Nike_Defaults:Nike_Defaults'].length); 
            if ((result['Nike_Defaults:Nike_Defaults'].length >= widget.defaults.numberOfProducts) && (ap_geoLang !== "NA_NA")) { //wips changed
                result = result[Object.keys(result)[0]];
                console.log('getGeoLangDefaultsx result : ', result);
                for (var key in result) {
                    productSet.push(result[key]);
                }
                //console.log('productSetCat : ',productSet, productSet.slice(0, 4), productSet.length, typeof productSet); 
                self.generateGallery(productSet.slice(0, widget.defaults.numberOfProducts),"GeoLanguageDefault"+"_"+ap_geoLang+"-"+ap_DataSignal1,"GeoLanguageDefault"+"_"+ap_geoLang);
                //reportingPrefix = "GeoLanguageDefault";
            } else {
                console.log('Geo Lang def not found. Call base default'); //Base default is not required as DB will always return _default_ in case of non matching.
                self.dynamicDataCallback("Nike_Defaults", "_default_", "loadDefault");
            }
        }
        this.loadDefault = function(result) {
            console.log('Base default loaded', result);
            //self.dynamicDataCallback("g_l_pid","ireland_english_12323776",2,"random","getProductIds");

            result = result[Object.keys(result)[0]];
            console.log('Base default resultx : ', result);
            for (var key in result) {
                productSet.push(result[key]);
            }
            //console.log('productSetCat : ',productSet, productSet.slice(0, 4), productSet.length, typeof productSet); 
            self.generateGallery(productSet.slice(0, widget.defaults.numberOfProducts),"BaseDefault"+"_"+ap_geoLang,"BaseDefault"+"_"+ap_geoLang);
            //reportingPrefix = "BaseDefault";
        };
        this.validateRetargetingProducts = function(cookieData) {
            console.log('validateRetargetingProducts loaded');
            var cookieProductsIds = cookieData.split(',');
            console.log('####### :', cookieProductsIds);
            cookieProductsIds.forEach(function(element) {
                //console.log(element);
                productIds.push(ap_geoLang + "_" + element);
            });
            console.log('productIds :', productIds);
            self.dynamicDataCallback("g_l_pid", productIds.join(','), "getProductIds");
        };
        this.validateAudienceId = function(id) {
            console.log('validateAudienceId loaded', id, id.length);
            var audienceSet = ap_geoLang + "_" + id;
            self.dynamicDataCallback("g_l_aid", audienceSet, "getaudienceSet");
        };
		this.validateConverterId = function(converterid) {
            console.log('validateConverterId loaded', converterid);
            self.dynamicDataCallback("line_items_id", converterid, "getConverterCat");
        };
        this.validateDSPId = function(dspid) {
            console.log('validateDSPId loaded', dspid);
            self.dynamicDataCallback("line_items_id", dspid, "getDSPCat");
        };
        this.callGeoLangDefaults = function(result) {
            console.log('callGeoLangDefaults loadedx', result);
            self.dynamicDataCallback("Nike_Defaults", result,"getGeoLangDefaults");
        };
        this.init = function() {
        	document.getElementsByTagName('body')[0].style.opacity = 0;
            _root["getProductIds"] = self.getProductIds;
            _root["getCatogoryProducts"] = self.getCatogoryProducts;
            _root["getaudienceSet"] = self.getaudienceSet;
            _root["getDSPCat"] = self.getDSPCat;
			 _root["getConverterCat"] = self.getConverterCat;
            _root["getDSPCatProducts"] = self.getDSPCatProducts;
			_root["getConverterCatProducts"] = self.getConverterCatProducts;
            _root["getGeoLangDefaults"] = self.getGeoLangDefaults;
            _root["loadDefault"] = self.loadDefault;
            
            

            console.log('Init called');
			console.log(ap_bestsellerID,ap_DataSignal8,ap_DataSignal1,"DS_Values");
            var cookieValG1_1 = self.getDynamicData('cookieData:cookieData.jvxdynsl_group1');
				console.log(cookieValG1_1,"cookiee_values_outside");
			if ((ap_DataSignal8 != "undefined") && (ap_geoLang !== "NA_NA")) {
				console.log('Converter Id available | Priority 0', ap_DataSignal8);
				var dspDS8 = ap_DataSignal8;
				console.log(dspDS8,"dspDS8");
                self.validateConverterId(dspDS8);
			} else if ((self.isRetargeting()) && (ap_geoLang !== "NA_NA") && (self.getDynamicData('cookieData:cookieData.jvxdynsl_group1'))) { //Retargeting - Priority 1 // && (1==2)
                console.log('isRetargeting | Priority 1 ');
                var cookieValG1 = self.getDynamicData('cookieData:cookieData.jvxdynsl_group1');
                self.validateRetargetingProducts(cookieValG1)
                console.log('productSet0 : ', productSet);
            } else if ((ap_geoLang !== "NA_NA")&& (typeof dynamicData != "undefined") && (typeof dynamicData['aid_report_B3'] != "undefined") && (dynamicData['aid_report_B3'].length >= 1) && (dynamicData['aid_report_B3'][0]['Reporting'] != "No Audience ID")) { //Audience catagory Id via DS2 (Feed) - Priority 2 
                console.log('Audience Id available | Priority 2', dynamicData['aid_report_B3'][0]['Reporting']);
                var dspDS2 = dynamicData['aid_report_B3'][0]['Reporting'];
				console.log(dspDS2,"dspDS2");
                self.validateAudienceId(dspDS2);
            } else if ((self.getDynamicData('tagVarService:tagVarService.DataSignal1')) && (ap_geoLang !== "NA_NA")) { //Prospecting DCM Id via DS1 (Google sheet) - Priority 3
                console.log('Prospecting DCM Id available | Priority 3', self.getDynamicData('tagVarService:tagVarService.DataSignal1'));
                var dspDS1 = self.getDynamicData('tagVarService:tagVarService.DataSignal1');
                self.validateDSPId(dspDS1);
            }
			else if ((ap_geoLang !== "NA_NA")) { //Default - Geo_Lang Default - Priority 4
                console.log('ap_geoLang matching | Priority 4', ap_geoLang);
                self.callGeoLangDefaults(ap_geoLang + "_default");
            } else { //Default - Universal Default - Priority 5 UK
                console.log('Base default loaded | Priority 5');
                //self.loadDefault();
                self.dynamicDataCallback("Nike_Defaults", "_default_", "loadDefault");
            }
        };
    }).apply(widget);
    _root["initiate"] = widget.init;

    function startAll() {
    	document.getElementsByTagName('body')[0].style.opacity = 1;
		var creativeDim = dynamicData['campaignProperties:campaignProperties.creativeDim'];
		//console.log("creativeDim",creativeDim);
        SPLASH.app.init();
        SPLASH.utils.autoSizeText();
		if(creativeDim == "320x50"){
			SPLASH.utils.autoSizeText1();
		}
		if(creativeDim == "120x600" || creativeDim == "160x600" || creativeDim == "300x600" || creativeDim == "320x50"){
			setTimeout(SPLASH.utils.positionTop, 500);
		}
		if(creativeDim == "970x250"){
			SPLASH.utils.positionCta();
		}
        $("#container").css("opacity", 1);
        //any better way of making sure the new textFields are rerendered?
        setTimeout(SPLASH.utils.positionPrice, 700);
        //console.log("count");
    }
	function startAllPros(){
			document.getElementsByTagName('body')[0].style.opacity = 1;
			SPLASH.app.initPros();
			SPLASH.utils.autoSizeText();
			if(widget.defaults.adSize == "320x50"){
				SPLASH.utils.autoSizeText1();
			}
			if(widget.defaults.adSize == "970x250"){
				SPLASH.utils.positionCta();
			}
			if(widget.defaults.adSize != "970x250"){
				setTimeout(SPLASH.utils.positionTop1, 500);
			}
			setTimeout(SPLASH.utils.positionPrice, 700);
			$("#container").css("opacity", 1);
	}

}(window, jvxAd, dynamicData));


